{ Processor IDs
 (C) 2005-2012, Andreas Berg. All Rights Reserved. }
unit _cpu;

interface

uses
 _common;

type
 TProcessor = record
    Name           : string;
    Value          : TAsmValue;
 end;

var
 ProcessorList     : array of TProcessor;
 ProcessorCount    : TDefValue;
 CurProcessor      : TDefValue;

procedure InitProcessors;
procedure AddProcessor(n: string; v: TAsmValue);

implementation

uses
 _error;

procedure InitProcessors;
begin
   CurProcessor:= Neg;
   SetLength(ProcessorList, 1);
   ProcessorCount:= 0;
end;

procedure AddProcessor(n: string; v: TAsmValue);
var
 pFound            : boolean;
 i                 : TDefValue;
begin
   pFound:= false;
   if (ProcessorCount > 0) then begin
      i:= 0;
      while i < ProcessorCount do begin
         if n = ProcessorList[i].Name then begin
            pFound:= true;
            break;
         end;
         Inc(i);
      end;
   end;
   if not pFound then begin
      SetLength(ProcessorList, ProcessorCount + 1);
      ProcessorList[ProcessorCount].Name:= n;
      ProcessorList[ProcessorCount].Value:= v;
      Inc(ProcessorCount);
      If CurProcessor = Neg then CurProcessor:= 0;
   end else begin
      ErrorMsg('Processor already exists [' + n + ']!');
   end;
end;

end.
